routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'App\Http\Controllers\CarController@index')->name('home');
Route::resource('/cars', 'App\Http\Controllers\CarController');
Route::post('/cars', 'App\Http\Controllers\CarController@index')->name('cars.index');
Route::post('/add/car', 'App\Http\Controllers\CarController@store')->name('cars.store');
Route::resource('/commands', 'App\Http\Controllers\CommandController');
Route::get('/commands/{id}/create', 'App\Http\Controllers\CommandController@create')->name('command.create');
Route::get('/login', 'App\Http\Controllers\UsersController@login')->name('users.login');
Route::post('/auth', 'App\Http\Controllers\UsersController@auth')->name('users.auth');
Route::post('/logout', 'App\Http\Controllers\UsersController@logout')->name('users.logout');
Route::get('/register', 'App\Http\Controllers\UsersController@create')->name('users.register');
Route::post('/register', 'App\Http\Controllers\UsersController@register')->name('users.register');
Route::get('/user/{id}/profile', 'App\Http\Controllers\UsersController@show')->name('users.profile');
Route::get('/admin', 'App\Http\Controllers\AdminsController@index')->name('admins.index');

app/Models/Car.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Car extends Model
{
    use HasFactory;

    protected $guarded = [];
}

app/Http/Controllers/CarController.php
<?php

namespace App\Http\Controllers;

use App\Models\Car;
use Illuminate\Http\Request;

class CarController extends Controller
{

    public function index(Request $request)
    {

        if ($request->search !== null) {
            $cars = Car::orderBy('created_at', 'DESC')->whereMarque($request->search)->paginate(4);
            return view('cars.index')->with([
                'cars' => $cars,
                'title' => "Resultat(s) trouvé(s) pour : " . $request->search, 
                'count' => $cars->count()
            ]);
        } else {
            $cars = Car::all();
            return view('cars.index')->with([
                'cars' => Car::paginate(4),
                'title' => "Toutes les voitures : ",
                'count' => $cars->count()
            ]);
        }


        
        $cars = Car::all();
        $dispo = ['50', '100', '150', '200','250', '300'];
        foreach ($cars as $car){
            $car->prixJ = $dispo[rand(0,5)];
            $car->save();
        }
        
    }
    public function store(Request $request){
        //
        $this->validate($request, [
            'marque' => 'required',
            'model' => 'required',
            'type' => 'required',
            'prixJ' => 'required',
            'dispo' => 'required',
            'image' => 'required'
        ]);
        $name = '';
        if($request ->hasFile('image')){
            $file = $request->image;
            $name = $file->getClientOriginalName();
            $file->move(public_path('image'), $name);
        }
        Car::create([
            'marque' => $request->marque,
            'model' => $request->model,
            'type' => $request->type,
            'prixJ' => $request->prixJ,
            'dispo' => $request->dispo,
            'image' => '/image/' . $name
        ]);
        return redirect()->route('admins.index')->withSuccess('BattleCar ajoutée ');
    }

    /**
     * @param \App\Models\Car $car
     * @return \Illuminate\Http\Response
     *
     */
    public function show(Car $car){

        //
        return view('cars.show')->withCar($car);
    }


    /**
     * @param Car $car
     *
     * @return \Illuminate\Http\Response
     */
    public function edit(Car $car){
        
        return view('cars.edit')->withCar($car);
    }


    /**
     * @param Request $request
     * @param Car $car
     *
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Car $car){
        
        $this->validate($request, [
            'marque' => 'required',
            'model' => 'required',
            'type' => 'required',
            'prixJ' => 'required',
            'dispo' => 'required',
        ]);
        $image = $car->image;
        if($request ->hasFile('image')){
            $file = $request->file('image');
            $name = $file->getClientOriginalName();
            $file->move(public_path('image'), $name);
            $image = '/image/'.$name;
        }
        $car->update([
            'marque' => $request->marque,
            'model' => $request->model,
            'type' => $request->type,
            'prixJ' => $request->prixJ,
            'dispo' => $request->dispo,
            'image' => $image
        ]);
        return redirect()->route('admins.index')->withSuccess('BattleCar modifié ');
    }

    
    /**
     * @param Car $car
     *
     * @return \Illuminate\Http\Response
     */

     public function destroy(Car $car){

        $car->delete();
        return redirect()->route('admins.index')->withSuccess('Voiture supprimé');
     }


}

resources/views/cars/edit.blade.php
@extends('layouts.header')

@section('content')
    <div class="container">
        <div class="row my-5">
            <div class="col-md-8 mx-auto">
                <div class="card bg-light">
                    <h3 class="card-header">Modifier une voiture</h3>
                    <div class="card-body">
                        <form action="{{route('cars.update', $car->id)}}" method="post" enctype="multipart/form-data">
                            @csrf
                            {{method_field('put')}}
                            <div class="form-group">
                                <label for="">Marque*</label>
                            <input type="text" name="marque" id="" class="form-control" value="{{$car->marque}}">
                            </div>
                            <div class="form-group">
                                <label for="">Model*</label>
                                <input type="text" name="model" id="" class="form-control" value="{{$car->model}}">
                            </div>
                            <div class="form-group">
                                <label for="">Type*</label>
                                <select name="type" id="">
                                    <option value="" selected disabled> Choisissez une type </option>
                                    <option value="Diesel"{{ $car->type == 'Diesel' ? 'selected' : ''}}>Diesel</option>
                                    <option value="Essence" {{ $car->type == 'Essence' ? 'selected' : ''}}>Essence</option>
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="">Prix Journalier*</label>
                                <input type="number" name="prixJ" id="" class="form-control" value="{{$car->prixJ}}">
                            </div>
                            <div class="form-group">
                                <label for="">Disponibilité*</label>
                                <select name="dispo" id="">
                                    <option value="" selected disabled> disponibilité voiture </option>
                                    <option value="1" {{ $car->dispo ? 'selected' : ''}}>Oui</option>
                                    <option value="0" {{ !$car->dispo ? 'selected' : ''}}>Non</option>
                                </select>
                            </div>
                            <div class="form-group">
                            <img src="{{$car->image}}" width="100" height="100" alt="" class="img-fluid">
                                <label for="">Image*</label>
                                <input type="file" name="image" id="" class="form-control" aria-describedby="helpId">
                            </div>
                            <button type="submit" class="btn btn-primary">Enregistrer modifications</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/cars/index.blade.php
@extends('layouts.header')

@section('content')



    <div class="col-my-4">

        <div class="col-md-8">
            <div class="card border border-black">
                <h3 class="card-header">{{ $title }} <span class="badge badge-black">{{ $count }}</span></h3>
                <div class="card-body">
                    @foreach ($cars as $car)
                        <div class="media mb-2">
                            <div class="media-left">
                                <img src="{{ $car->image }}" width="100" height="100" class="img-fluid rounded-circle" alt="">
                            </div>
                            <div class="media-body">
                                <h3 class="text-info">
                                <a href="{{route('cars.show', $car->id)}}" class="btn btn-link">
                                       {{ $car->marque }}
                                    </a>
                                </h3>
                                <p class="d-flex flex-row justify-content-start">
                                    <span class="badge badge-danger mx-3">Type: {{ $car->type }}</span>
                                    <span class="badge badge-primary mr-3">Prix Journalier: {{ $car->prixJ }} €</span>
                                    @if ($car->dispo)
                                        <span class="badge badge-success">
                                            Disponible à la location
                                        </span>
                                    @else
                                        <span class="badge badge-warning">
                                            Indisponible
                                        </span>
                                    @endif
                                </p>
                            </div>
                        </div>
                        <hr>
                    @endforeach
                </div>
                <div class="d-flex justify-content-center">
                    {!! $cars->links() !!}
                </div>
            </div>
            
        </div>
    </div>

@endsection

resources/views/cars/show.blade.php
@extends('layouts.header')

@section('content')

    <div class="col-my-4">
        

        <div class="col-md-8">
            <div class="card border border-black">    
                <h3 class="card-header">{{ $car->marque }}</h3>
                <div class="card-body">
                    <div class="car-img-top">
                        <img src="{{ $car->image }}" class="img-fluid rounded m-2" alt="">
                    </div>
                    <p class="d-flex flex-row justify-content-start">
                        <span class="badge badge-danger mx-3">Type: {{ $car->type }}</span>
                        <span class="badge badge-primary mr-3">Prix Journalier: {{ $car->prixJ }} €
                        </span>
                        @if ($car->dispo)
                            @auth
                                <p>
                                    <a href="{{route('command.create', $car->id)}}" class="btn btn-primary">Réserver</a>
                                </p>
                            @else
                                <p>
                                    <a href="{{route('users.login')}}" class="btn btn-primary">Réserver</a>
                                </p>
                            @endauth
                        @else
                            <span class="badge badge-warning">
                                Réservé
                            </span>
                        @endif
                    </p>
                </div>
            </div>
        </div>
    </div>
@endsection